//   Модуль формирования единичного импульса разрешения звука от нажатия кнопки.
// 
module  buzzer_butt(
        input clk,	
	     input en_buzzer_key,
	     output en_buzzer_button
	);

reg[8:0] counter; // счетчик для подсчета счетных импульсов

reg reg_en_buzzer_button = 0;	 // переменная состояния  импульса разрешения звука

parameter   POROG_IMP = 100;       //  количество счетных импульсов, задающее длительность 
                                    // формируемого единичного импульса разрешения звука  

// формирование  единичного  импульса  по нажатию кнопки  
always @(posedge clk) 
begin
       if (en_buzzer_key)
	        begin
		       counter <= 0;
		       reg_en_buzzer_button <= 1; // начать  импульс 
		     end
       else
           begin	
	          if (counter >= POROG_IMP) 
		          begin
			         reg_en_buzzer_button <= 0; // закончить  импульс
			       end
		       else
	             begin
		            counter <= counter + 1;
                end 		
           end 
end 

assign en_buzzer_button = reg_en_buzzer_button;  

endmodule