//   Модуль  фильтра дребезга контактов кнопки. 
// при поступленни входного перепада key_in  активного (низкого)  уровня 
// начинается  накопление операционных счетных импульсов, продолжающееся, 
// пока длится входной импульс. Если он кончается,  а накопление не достигло порога,  
// накопленное  сбрасывается. 
// Если порог достигнут, входной отрицательный перепад передается на выход  noise_key_out
//   Помимо подавления дребезга модуль формирует длительность выходного   отрицательного  
// импульса строго 1 период clk, причем положительный перепад clk  приходится на середину этого импульса    
//   
module  noise_filter_butt(
     input clk, 	
	  input key_in, 
	  output edge_noise_key_out
	);
	

reg[8:0] counter_clk_key;  // счетчик  счетных импульсов для сравнения с  порогом пропуска 
                          // входного сигнала на выход   
reg Q1 = 1;
reg Q2 = 1;
reg noise_key_out = 1;
 
  
parameter   POROG =  100;    // порог -  количество счетных импульсов после которого 
                           //  принимается решение о пропуске входного сигнала на выход   
    
// накопление некоторого количества счетных импульсов для обеспечения  подавления дребезга 
always@(posedge clk)
  begin
     if (!key_in) 
	      begin 		
           if(counter_clk_key >= POROG)    
             begin 
	           noise_key_out <= 0;
	          end
           else
			    begin 
			     counter_clk_key <= counter_clk_key + 1;  				 
				 end   
			end 
     else 
	      begin 
			  noise_key_out <= 1; 
			  counter_clk_key <= 0;
			end   
  end
	  
	  
// двухступенчатый триггер для формирования отрицательного импульса  длительностью 1 период clk 
// положительный перепад clk приходится на середину этого импульса  	  
always@(posedge (~clk)) 	  
  begin  
   Q1 <= noise_key_out;
	Q2 <= Q1; 
  end  
	  
// комбинационная часть формирователя отрицательного импульса  длительностью 1 период clk 	
assign edge_noise_key_out = Q1|(~Q2);	
		 		
endmodule